from toloka.client.primitives.base import BaseTolokaObject
from typing import (
    Any,
    Dict,
    Optional
)

class OperationLogItem(BaseTolokaObject):
    """Objects of which the operation log consists

    Contains information about the validation errors and what sets of objects were created.

    Attributes:
        type: Type of action in the operation step.
        success: Result of the step (true or false).
        input: Input data at the operation step.
        output: Operation step output. Depends on the type.
    """

    def __init__(self, *, type: Optional[str] = None, success: Optional[bool] = None, input: Optional[Dict[str, Any]] = None, output: Optional[Dict[str, Any]] = None) -> None:
        """Method generated by attrs for class OperationLogItem.
        """
        ...

    _unexpected: Optional[Dict[str, Any]]
    type: Optional[str]
    success: Optional[bool]
    input: Optional[Dict[str, Any]]
    output: Optional[Dict[str, Any]]
