from toloka.client.primitives.base import BaseTolokaObject
from typing import (
    Any,
    Dict,
    Optional
)

class Owner(BaseTolokaObject):
    """Parameters of the customer who created an object.

    Attributes:
        id: Customer ID.
        myself: An object accessory marker.
            Possible values:
                * True - an object created by the customer whose OAuth-токен in the request;
                * False - an object does not belong to the customer whose OAuth-токен in the request.
        company_id: ID of the customer's company.
    """

    def __init__(self, *, id: Optional[str] = None, myself: Optional[bool] = None, company_id: Optional[str] = None) -> None:
        """Method generated by attrs for class Owner.
        """
        ...

    _unexpected: Optional[Dict[str, Any]]
    id: Optional[str]
    myself: Optional[bool]
    company_id: Optional[str]
